#
# spec file for package ndiswrapper (Version 1.8)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kernel-source kernel-syms klogd less libacl libattr libcom_err libgcc libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           ndiswrapper
BuildRequires:  kernel-source kernel-syms
Group:          System/Kernel
Autoreqprov:    on
Summary:        Use Microsoft NDIS Network Drivers for WLAN Cards
Version:        1.9
Release:        1
Requires:       pciutils
Source0:        %name-%version.tar.bz2
Source1:        Makefile.in
Source2:        README.SUSE
Patch0:         ndiswrapper.diff
URL:            http://ndiswrapper.sourceforge.net
License:        GPL
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch: %ix86 x86_64
#%suse_kernel_module_package kdump um
%define flavors_to_build default

%description
Some wireless LAN vendors refuse to release hardware specifications or
drivers for their products for operating systems other than Microsoft
Windows. The ndiswrapper project makes it possible to use such hardware
with Linux by means of a loadable kernel module that "wraps around"
NDIS (Windows network driver API) drivers.



Authors:
--------
    Pontus Fuchs <pof@users.sourceforge.net>

%debug_package
%package KMP
Group:          System/Kernel
Summary:        Use Microsoft NDIS Network Drivers for WLAN Cards

%description KMP
Some wireless LAN vendors refuse to release hardware specifications or
drivers for their products for operating systems other than Microsoft
Windows. The ndiswrapper project makes it possible to use such hardware
with Linux by means of a loadable kernel module that "wraps around"
NDIS (Windows network driver API) drivers.



Authors:
--------
    Pontus Fuchs <pof@users.sourceforge.net>

%prep
%setup
%patch0 -p1
cp %SOURCE2 .
mkdir obj

%build
CFLAGS="$RPM_OPT_FLAGS" make -C utils
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
sed -e "s/@DRV_VERSION@/%{version}/" \
	%_sourcedir/Makefile.in > driver/Makefile
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r driver obj/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
       M=$PWD/obj/$flavor
done

%install
rm -rf %buildroot
install -d -m 755 %buildroot/sbin %buildroot/usr/sbin \
    %buildroot/etc/ndiswrapper
# Userspace stuff
install -m 755 utils/loadndisdriver %buildroot/sbin
install -m 755 utils/ndiswrapper %buildroot/usr/sbin
# Kernel module
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
     make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
        M=$PWD/obj/$flavor
done

%files
%defattr(-, root, root)
/etc/ndiswrapper
/sbin/loadndisdriver
/usr/sbin/ndiswrapper
/lib/modules/*
%doc README
%doc README.SUSE
%doc INSTALL
%doc AUTHORS
%doc ChangeLog

%changelog -n ndiswrapper
* Sat Feb 11 2006 - joe_morris@ntm.org
- updated to 1.9
* Fri Feb 03 2006 - jg@suse.de
- converted to Kernel Module Package
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 - jg@suse.de
- update to version 1.8, changes:
  * Issue with WEP with wpa_supplicant fixed (keys must be saved
  and restored).
  * Support for newer kernels added.
  * Crash when removing ndiswrapper module with certain Windows
  drivers fixed.
* Mon Jan 02 2006 - jg@suse.de
- Fixed Makefile.in (usb module was missing)
* Thu Dec 22 2005 - jg@suse.de
- update to version 1.7, changes:
  * Drivers and driver files are dynamically loaded and unloaded as
  and when necessary; this should save memory.
  * Support for Highmem with USB devices added.
  * Bulk and interrupt URBs were being mixed up in earlier releases
- this issue is fixed.
  * Crashes due to 'divide by zero' error in update_wireless_stats fixed.
  * Support for Atheros USB drivers, including RangeMAX MIMO,  added.
  * Suspend and resume support improved; USB devices should now be
  able to suspend and resume.
* Tue Nov 08 2005 - jg@suse.de
- update to version 1.5, changes:
  * SMP issues fixed.
  * Zero-copy for sending packets implemented.
  * If a device doesn't resume properly (from suspend), de-initialize
  device so it can be initialized later. This fixes issue with
  suspend/resume with Marvell driver.
  * Issues with WUSB11v4 (Ali chipset) fixed.
  * Rtl string functions have been reimplemented.
  * Resume from suspend works with Marvell chipset 8335.
* Thu Oct 27 2005 - jg@suse.de
- update to version 1.4, changes:
  * WPA2 support added.
  * Implemented most of IO manager, PnP manager and Obj manager.
  * No need to update utils everytime ndiswrapper is updated but
  only when utils interface changes.
  * USB layer has been rewritten with many fixes; e.g., USB devices
  no longer disconnect unexpectedly.
  * New devices supported: sis162, sis163, ZyDas 1211, Linksys
  WUSB11v4 (with Ali chipset). These are USB devices.
  * Unplugging USB devices without removing ndiswrapper module
  supported.
  * USB devices work with PREEMPT enabled.
  * Separate workqueue is used in 2.6 kernels; this should prevent
  locking up keyboard etc. in case of kernel crash.
  * Support for new kernels added.
  * Many bug fixes.
  * Added support for Inprocomm IPN2220 with 64-bit.
  * Added support for RNDIS USB devices (tested with U.S. Robotics
  USR5420).
  * Issue with unloading module with some drirvers (e.g., sis and
  Inprocomm ipn2220) fixed.
  * Issue with WPA with sis162u, sis163u and ZyDas zd1211 fixed.
* Mon Jul 18 2005 - jg@suse.de
- update to version 1.2, changes:
  * Support for NX (no-execute) bit
  * 64-bit Broadcom driver works with HIGHMEM.
  * Implemented I/O manager layer.
  * Many bug fixes
* Fri Mar 11 2005 - jg@suse.de
- enabled building on x86_64
* Mon Mar 07 2005 - jg@suse.de
- update to version 1.1, changes:
  * Yet another spinlock (re)implementation. We don't use Linux
  spinlocks to implement Windows spinlocks anymore - ndiswrapper
  implements new spinlock functions that use Windows spinlock
  variables directly.
  * Use kmem_cache pools for MDL (aka NDIS_BUFFER) and NDIS_PACKET
  structures which are allocated often. This should reduce memory
  fragmentation.
  * Use MDL functions when initializing ndis_packet while sending
  packets. This fixes crashes with Fedora kernels (and amd64
  driver at least).
  * Memory leak with 64-bit Broadcom driver fixed
  * Crash when module is removed with Marvell driver fixed
  * In some cases, a Windows driver loads successfully, but
  ndiswrapper concludes otherwise. This is fixed.
* Fri Feb 11 2005 - jg@suse.de
- added missing object file in Makefile
* Mon Feb 07 2005 - jg@suse.de
- update to version 1.1rc1, changes:
  * Don't use spinlocks unless CONFIG_SMP or CONFIG_DEBUG_SPINLOCK
  is enabled.
  * Don't reset Centrino cards during initialization as this seems
  to turns off radio.
  * Set the active/transmit key index as given, instead of assuming
  1 always. This fixes authentication with Cisco routers. This
  should also fix WEP issues when active key used on the router
  is at index > 1.
  * NdisAcquire(Dpr)SpinLock obtains the lock at DISPATCH_LEVEL
  instead of PASSIVE_LEVEL. This fixes PREEMPT and SMP issues
  with some drivers.
  * Issue with Prism54 driver sometimes crashing kernel when
  scanning fixed.
  * WavePlus 1200 chipset supported.
  * Works with some vendor kernels that use different semantcis
  (from vanilla kernels) for PCI/USB register functions.
  * Don't free memory allocated for 'devices' twice (which was
  causing kernel crash) when device registration failed.
  * Don't set infrastructure mode in wpa_associate, which clears
  the keys. With this, WEP should work again with wpa_supplicant.
  * Fix (small) memory leak - free xmit_array when device is removed.
  * Use spinlock when calling any miniport function. This may fix
  some SMP issues.
  * Preliminary support for AMD64 (tested with Broadcom chipset)
  * Dynamic loader support: A driver is loaded only when necessary,
  so even if many drivers are installed or if a driver installs
  many .conf files (e.g., Centrino), only drivers and device
  configurations necessary are loaded.
  * Set RadioState used by Broadcom drivers to 0, instead of 1. This
  turns on radio (although name suggets the other way round).
  * Sends multiple packets (if driver supports it) in each send
  operation for better efficiency
  * Most of the functionality of loader is moved to userspace tool
  loadndisdriver so it is more robust
  * Encryption info is restored during disassociation; this is useful
  if ad-hoc mode is used as psuedo master mode
  * MAC address can be set in .conf files or changed at any
  * Association and disassociation should happen quickly especially
  with wpa_supplicant
* Thu Dec 16 2004 - jg@suse.de
- update to version 0.12, changes:
  * Works with Preempt and SMP kernels.
  * WPA-RADIUS is supported.
  * Compiles with kernels > 2.6.9 and swsuspend2
  * USB cards are reset during initialization; they should work
  without having to reset explicitly
  * Some crashes in USB, especially during initialization, are
  fixed.
  * WEP key setting problems fixed.
  * Check for 4K stack size during compilation and issue warning
  if necessary.
  * Bug fixes
* Fri Oct 22 2004 - jg@suse.de
- update to version 0.11, changes:
  * Compilation issues with USB are fixed
  * WPA issues fixed
  * Older Prism USB devices supported
  * Suspend/resume of devices with no power management (e.g., TI)
  fixed
  * ndiswrapper script has an option "-d" to install drivers for a
  different device (if the chipset is same)
  * ndiswrapper script lists USB devices and reports status of
  drivers with more understandable messages
  * Lots of bug fixes and improvements
- registering all devices with driver name 'ndiswrapper', so ifup
  scripts have the possibility to recognize ndiswrapper
- fixed sysfs links (device/driver links were missing)
* Tue Oct 05 2004 - agruen@suse.de
- Add a README.SUSE.
* Mon Sep 27 2004 - agruen@suse.de
- Update to version 0.10.
* Fri Jun 11 2004 - agruen@suse.de
- Update to version 0.8.
* Mon Mar 29 2004 - agruen@suse.de
- Add missing object file.
* Mon Mar 29 2004 - agruen@suse.de
- Fix a thinko: Exporting the module version works for the test
  build, but doesn't help in the binary kernels.
* Sun Mar 28 2004 - agruen@suse.de
- Update to version 0.6+CVS.
* Tue Mar 09 2004 - agruen@suse.de
- Update to version 0.5 + regparm fix.
* Sat Feb 21 2004 - agruen@suse.de
- CVS update.
* Mon Jan 26 2004 - ro@suse.de
- create directory before use
* Sun Jan 25 2004 - agruen@suse.de
- Remove /etc/modprobe.d from the file list: This is in the
  module-init-tools package now.
* Fri Jan 23 2004 - agruen@suse.de
- Only build on i386 non-SMP kernels.
* Sat Jan 17 2004 - agruen@suse.de
- Skip building the kernel module on SMP systems.
- Add sysconfig settings and SuSEconfig script.
* Tue Jan 13 2004 - agruen@suse.de
- spec file: BuildArch should really be ExclusiveArch.
* Mon Jan 12 2004 - agruen@suse.de
- Fix directory ownership for rpm.
* Mon Jan 12 2004 - agruen@suse.de
- Initial package.
